<?php
    require_once('vendor/autoload.php');
    use Monolog\Level;
    use Monolog\Logger;
    use Monolog\Handler\StreamHandler;
    use Monolog\Handler\FirePHPHandler;
    echo "\n";

    // Create the logger
    $logger = new Logger('my_logger');
    // Now add some handlers
    $logger->pushHandler(new StreamHandler(__DIR__.'/my_app.log', Level::Debug));
    $logger->pushHandler(new FirePHPHandler());
    $logger->info('This is a log! ^_^ ');

    //look through data folder and process each subfolder
    $directories = glob("data/*",GLOB_ONLYDIR);
    foreach($directories as $directory){

        $dictionary = array();

        //get all text files inside folder
        $text_files = glob($directory . "/*.txt");
        foreach($text_files as $file_name) {
            $file_handle = fopen($file_name, "r"); 
            $file_string = fread($file_handle, filesize($file_name));
            $file_string = strtolower($file_string);
            $file_string = str_replace("\"", "", $file_string);
            $file_string = str_replace("!", ".", $file_string);
            $file_string = str_replace("?", ".", $file_string);
            $file_string = str_replace(",", "", $file_string);
            $file_string = str_replace("  ", " ", $file_string);
            
            $sentence_list = explode(".", $file_string);

            foreach($sentence_list as $sentence){
                if(substr($sentence,0,1) == " "){
                    $sentence = substr($sentence,1);
                }

                if(strlen($sentence) == 0){
                    continue;
                }

                $word_list = explode(" ", $sentence);
                $is_five_gram = count($word_list) >= 5;

                echo "\n";
                for($i = 0; $i < count($word_list); $i++){
                    if(array_key_exists($word_list[$i], $dictionary) && $is_five_gram){
                        $dictionary[$word_list[$i]][0] += 1;

                        //create five gram
                        $sentence = array();
                        $tempIndex = $i - 2;
                        for($wordNumber = 0; $wordNumber < 5; $wordNumber++){
                            if($tempIndex < 0){
                                array_push($sentence,"[blank]");
                            }else if($tempIndex >= count($word_list)){
                                array_push($sentence,"[blank]");
                            }else{
                                array_push($sentence,$word_list[$tempIndex]);
                            }
                            $tempIndex += 1;
                        }

                        array_push($dictionary[$word_list[$i]], $sentence);
                        
                    }else if(array_key_exists($word_list[$i], $dictionary)){
                        $dictionary[$word_list[$i]][0] += 1;
                    }else if($is_five_gram){
                        $dictionary[$word_list[$i]] = [1];

                        //create five gram
                        $sentence = array();
                        $tempIndex = $i - 2;
                        for($wordNumber = 0; $wordNumber < 5; $wordNumber++){
                            if($tempIndex < 0){
                                array_push($sentence,"[blank]");
                            }else if($tempIndex >= count($word_list)){
                                array_push($sentence,"[blank]");
                            }else{
                                array_push($sentence,$word_list[$tempIndex]);
                            }
                            $tempIndex += 1;
                        }
                        array_push($dictionary[$word_list[$i]], $sentence);
                    }else{
                        $dictionary[$word_list[$i]] = [1];
                    }
                }
            }

            fclose($file_handle);
            $logger->info('Processed: ' . $file_name);
        }

        uasort($dictionary, function ($a, $b) {
            return $b[0] - $a[0];
        });
        foreach($dictionary as $key=>$value){
            echo $key . ": ";
            for($i = 0; $i < count($value); $i++){
                if($i == 0){
                    echo $value[0] . " ";
                }else{
                    for($j = 0; $j < count($value[$i]); $j++){
                        echo $value[$i][$j] . " ";
                    }
                    echo ", ";
                }
            }
            echo "\n";
        }
        //serialize array
        echo $directory;
        $fileName = "quiz/"  . substr($directory,5) . ".txt";
        $serializedDictionary = serialize($dictionary);
        $file_handle = fopen($fileName, "w");
        fwrite($file_handle, $serializedDictionary);
    }