<?php
namespace solo\hw4\views;

class LandingView{
    function __construct(){

    }

    function render($quizNames){
        ?>
        <!DOCTYPE html>
        <html>
            <head>
                <title>Language Quiz</title>
            </head>
            <body>
                <h1><a href="index.php?c=landing">Language Quiz</a></h1>
                    <select id="languageQuiz">
                        <option disabled selected hidden value="default">Choose a quiz</option>
                        <?php
                            foreach($quizNames as $quizName){
                                echo "<option>{$quizName}</option>";
                            }
                        ?>
                    </select>
                    <br/>
                    <label>Years of Experience:</label>
                    <input min=0 type="number" id="yoe" name="yoe">
                    <br/>
                    <button id="startQuiz">Start Quiz</button>
                    <button id="seeResults">See Results</button>
                    <div id="errorQuiz" style="visibility:hidden; color:red;">A quiz has not been selected</div>
                    <div id="errorExp" style="visibility:hidden; color:red;">Experience has not been entered</div>
            </body>
            <script type="text/javascript">
                document.getElementById("startQuiz").addEventListener('click', function(){
                    if(document.getElementById("languageQuiz").value == "default"){
                        console.log("User has not selected a quiz");
                        document.getElementById("errorQuiz").style.visibility='visible';
                    }
                    else if(document.getElementById("yoe").value == ""){
                        document.getElementById("errorQuiz").style.visibility='hidden';
                        console.log("User has not entered their years of experience");
                        document.getElementById("errorExp").style.visibility='visible';
                    }
                    else if(Number(document.getElementById("yoe").value) < 0){
                        console.log("User has entered an invalid number of years of experience");
                    }
                    else{
                        document.getElementById("errorQuiz").style.visibility='hidden';
                        document.getElementById("errorExp").style.visibility='hidden';

                        let quizName = document.getElementById("languageQuiz").value;
                        let yoe = document.getElementById("yoe").value;
                        console.log(document.URL);
                        let indexQMark = document.URL.indexOf('?');
                        let baseUrl = document.URL.substring(0,indexQMark);
                        document.location.href = baseUrl + "?c=quiz&name=" + quizName + "&yoe=" + yoe;
                    }
                });
                document.getElementById("seeResults").addEventListener('click', function(){
                    if(document.getElementById("languageQuiz").value == "default"){
                        console.log("User has not selected a quiz");
                        document.getElementById("errorQuiz").style.visibility='visible';
                    }
                    else{
                        let quizName = document.getElementById("languageQuiz").value;
                        let yoeValue = document.getElementById("yoe").value;
                        let yoe;
                        if(yoeValue < 10 && yoeValue >= 0){
                            yoe = 'less10';
                        }else if(yoeValue >= 10 && yoeValue <= 20){
                            yoe ='10-20';
                        }else if(yoeValue > 20){
                            yoe = '20';
                        }else{
                            yoe = 'any';
                        }
                        let indexQMark = document.URL.indexOf('?');
                        let baseUrl = document.URL.substring(0,indexQMark);
                        document.location.href = baseUrl + "?c=results&name=" + quizName + "&yoe=" + yoe;
                    }
                });
            </script>
        </html>
        <?php        
    }
}